--Created by Jonathan de Blok - http://ww.jdbgraphics.nl - jonatahn@jdbgraphics.nl
--Provided free of charge, and as is, for both personal and commercial use, enjoy!

-- 07/aug/2011 - version 2.2 
-- More Bugfixes and even better performace.
-- Animated materials now work as expected to. 
-- When modifier is disabled they objects 'normal' keys are now adjustable in the trackview in normal time scope.

-- 06/aug/2011 - version 2.1 BETA
-- Bugfixes and performace boost when  applies to lots of objects. Curve editor still slow.
--

-- 06/aug/2011 - version 2.0 BETA
-- New method, now uses the EaseCurve functions instead of shifting keyframes (thx @ DenisT for the tip :)

-- 05/aug/2011 - version 1.0 BETA


plugin modifier Timewarp
name:"Timewarp"
classID:#(685325,452282)  version:2
(
  
 	on create do
	( 
		this.twarp.controller = bezier_float() -- this hold the timewarp value
		this.curveMaster.controller =  float_script()  -- this is the 'master' easeCurve, is instanced across all other controllers
		this.trigger.controller =   float_script script:"currentTime.ticks"  -- needed for trick to get the trackview to display the 'normal' time when the modifier is disabled
	)

	parameters main rollout:params
	(
		twarp type:#float animatable:true ui:twarp default:0.0  
		curveMaster type:#float animatable:true default:0.0 
		trigger type:#float animatable:true  default:0.0 
		
		on twarp get val do 
		(	   
		
			local objs = refs.dependentnodes  this   -- returns all nodes the  modifiers affects
 
			if (objs[1]!=undefined AND (numEaseCurves this.curveMaster.controller)>0 ) do
			( 
				with undo off (
					with animate off
					(	
						if (this.enabled==true AND this.curveMaster.controller.ease_curve != (val as time)  ) then 
						( 
							--set the curveMasters script source string  as the modifier's spinner value (in ticks) 
							this.curveMaster.controller.ease_curve.controller.script = (val as time).ticks as string 
						)
					
						if (this.enabled==false) do
						(
							--If modifier is disabled, the master script jsut return the currentTime, so the easecurves just follow the normal timeline time.		
						 	this.curveMaster.controller.ease_curve.controller.script ="currentTime.ticks" 
						)
					)
				)
			)
			
			-- return input value as required by the event.
			val
		)
	)
 
	-- define the interface
	rollout params "Timewarp Parameters"
	(   
		button ec_recreate "(Re)create EaseCurves"
		button ec_remove  "Remove all EaseCurves"
		spinner twarp "Timewarp:"  range:[-1000000,1000000,0]
 

		-- update (remove and recreate) all easeCurves
		on ec_recreate pressed do
		( 	
			--close open trackviews, cause slowdown when left open while creating

			
			local objs = refs.dependentnodes  this 
			local bf= float_script()
			for i=1 to objs.count do (
				try( deleteEaseCurve objs[i] 1 ) catch()
				try( deleteEaseCurve objs[i].material 1 ) catch()
			)
				
			try ( deleteEaseCurve this.curveMaster.controller 1 ) catch()	
			
			for i=1 to objs.count do
			(
				--add easeCurve to everything
				addEaseCurve objs[i] bf
				--but not one these 2, the should remain on the main time
				deleteEaseCurve   this.twarp.controller 1
				deleteEaseCurve   this.trigger.controller 1
				
				-- delete any doube easeCurve assingment do to instancing and such
				try( deleteEaseCurve objs[i].material 2 ) catch()
 				try( deleteEaseCurve  this.curveMaster.controller 2) catch()
			)
			
	)
		
		--Remove all the easeCurves
		on ec_remove pressed do
		(
			local objs = refs.dependentnodes  this 
	 
				--strip all objects of their easeCurves
				for i=1 to objs.count do
				(
					try( deleteEaseCurve objs[i] 1 ) catch()
					
					--max doesn't remove material's easeCurves by default, so do it like this:
					try( deleteEaseCurve objs[i].material 1 ) catch()
				)
							 
			try (deleteEaseCurve this.curveMaster.controller 1 ) catch()		
		)	
	)
)
